<!-- table -->
<app-table
  (pagingChange)="emitPagingChange($event)"
  (sortChange)="emitSortsChange()"
  [columns]="columns"
  [loading]="loading"
  [page]="page"
  [rows]="data"
  [size]="size"
  [loadLabel]="loadMoreLable"
  [total]="total"
>
  <!-- date -->
  <ng-template appTableBodyCell columnProperty="createdAt" let-createdAt="value">
    <span class="column-label dh ms">{{ 'DATE ACCESS' }}</span>
    {{ createdAt | date: 'MM/dd - hh:mm' }}
  </ng-template>

  <!-- device -->
  <ng-template appTableBodyCell columnProperty="device" let-device="value">
    <!-- device info -->
    <div class="app-device">
      <!-- tooltip -->
      <app-tooltip position="top">
        <!-- name -->
        <div (click)="openDeviceInfo(device)" class="app-link name">
          {{ device.name }}
        </div>
        <b tooltip>
          {{ device.name }}
        </b>
      </app-tooltip>

      <!-- sn -->
      <div class="app-sn">
        DEVICE SN: <span>{{ device.sn }}</span>
      </div>
    </div>
  </ng-template>

  <!-- keyholder -->
  <ng-template appTableBodyCell columnProperty="keyholder" let-keyholder="value">
    <span class="column-label dh ms">keyholder</span>
    <!-- keyholder info -->
    <app-user-info
      (nameClick)="openKeyholderInfo(keyholder)"
      [clickable]="true"
      [tooltipVisible]="true"
      [user]="keyholder"
      type="key"
    ></app-user-info>
  </ng-template>

  <!-- errorInfo -->
  <ng-template appTableBodyCell columnProperty="errorInfo" let-history="row">
    <span class="column-label dh ms">error code</span>
    <!-- errorInfo info -->
    <ng-container *ngIf="hasError(history); else na">
      <!-- error content -->
      <app-error-code [errorInfo]="history.errorInfo"></app-error-code>
    </ng-container>

    <!-- not available -->
    <ng-template #na>
      <div class="app-na">
        N/A
      </div>
    </ng-template>
  </ng-template>

  <!-- map -->
  <ng-template appTableBodyCell columnProperty="map" let-history="row">
    <app-icon-map class="dh ms"></app-icon-map>

    <!-- tooltip -->
    <app-tooltip class="ds mh" *ngIf="history.map" position="top">
      <!-- map icon -->
      <app-icon-map></app-icon-map>
      <b tooltip>
        View Map
      </b>
    </app-tooltip>
  </ng-template>
</app-table>

<!-- device info -->
<app-side-modal-device-info
  (updated)="onInfoUpdated()"
  (closeClick)="closeDeviceInfo()"
  *ngIf="deviceInfoVisible"
  [device]="selectedDevice"
></app-side-modal-device-info>

<!-- keyholder info -->
<app-side-modal-keyholder-info
  (updated)="onInfoUpdated()"
  (closeClick)="closeKeyholderInfo()"
  *ngIf="keyholderInfoVisible"
  [user]="selectedKeyholder"
></app-side-modal-keyholder-info>
